      DOUBLE PRECISION FUNCTION HZPYAVRG(nev)
C     ---------------------------------------------------------------------
C     Returns the average charged multiplicity for PYTHIA events.
C     PYTHIA is assumed to have been already initialised.
C     Author: Jon Butterworth
C     ---------------------------------------------------------------------
      IMPLICIT NONE

#include "hepevtp.inc"

      INTEGER nev, navrg, i, evloop

      navrg = 0
      do evloop=1,nev

         if (mod(evloop,100).EQ.0) write(*,*) 'hzpyavrg: evloop',evloop
         CALL PYEVNT
         CALL HZFILHEP

         do I=1,NHEP
            
            if((IDHEP(I).eq.11).or.(IDHEP(I).eq.-11).or. 
     &           (IDHEP(I).eq.13).or.(IDHEP(I).eq.-13).or.
     &           (IDHEP(I).eq.15).or.(IDHEP(I).eq.-15).or.
     &           (IDHEP(I).eq.2212).or.(IDHEP(I).eq.-2212).or.
     &           (IDHEP(I).eq.211).or.(IDHEP(I).eq.-211).or.
     &           (IDHEP(I).eq.321).or.(IDHEP(I).eq.-321).or.
     &           (IDHEP(I).gt.3000).or.(IDHEP(I).lt.-3000))then
               
               navrg = navrg + 1
            endif
         enddo
         
      enddo
	   
      hzpyavrg = navrg*1.d0/nev

      RETURN 
      END




